import logging
from logging.config import dictConfig

# look into: https://www.packetmischief.ca/2017/10/25/3-ways-to-fail-at-logging-with-flask/
# source: https://docs.python.org/3/howto/logging-cookbook.html (An example dictionary-based configuration)
# discussion: https://github.com/pallets/flask/issues/2023
LOGGING = {
    'version': 1,
    'disable_existing_loggers': True,
    'formatters': {
        'verbose': {
            'format': '%(levelname)s %(asctime)s %(module)s %(process)d %(thread)d %(message)s'
        },
        'simple': {
            'format': '%(levelname)s %(message)s'
        },
    },
    'handlers': {
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'simple'
        },
    },
    'loggers': {
        'flask': {
            'handlers': ['console'],
            'propagate': False,
            'level': 'INFO',
        },
        'portal': {
            'handlers': ['console'],
            'level': 'DEBUG',
            'propagate': False,
        }
    }
}

logging.config.dictConfig(LOGGING)

log = logging.getLogger('portal')
