from portal import create_app
from portal import db
from sample_data.data_init import init_data

from portal.rest.courses.courses import courses
from portal.rest.users.users import users
from portal.rest.roles.roles import roles
from portal.rest.groups.groups import groups


def init_db(app):
    db.drop_all(app=app)
    db.create_all(app=app)


if __name__ == '__main__':
    app = create_app()
    init_db(app)
    init_data(app, db)
    app.register_blueprint(courses)
    app.register_blueprint(users)
    app.register_blueprint(roles)
    app.register_blueprint(groups)
    # app.run(use_reloader=False)
    app.run()

'''
# look into: flask-login extension (user authentication)
# flask-migrate
# use blueprints for the app - http://flask.pocoo.org/docs/0.12/blueprints/#blueprints
# flask-wtf for auth
# https://scotch.io/tutorials/build-a-crud-web-app-with-python-and-flask-part-one

logging: (email sending!):
http://flask.pocoo.org/docs/dev/logging/
https://docs.python.org/3/howto/logging-cookbook.html#formatting-styles

REST & js:
https://auth0.com/blog/developing-restful-apis-with-python-and-flask/
https://blog.miguelgrinberg.com/post/designing-a-restful-api-with-python-and-flask

Extensions for timestamping entities and _repr:
https://sqlalchemy-utils.readthedocs.io/en/latest/models.html#sqlalchemy_utils.models.Timestamp
'''