from portal.database.models import User, Course, Project, Group, Role, Submission, Review


def init_data(app, db):
    with app.app_context():
        create_users(db)
        create_courses(db)
        create_groups(db)
        create_projects(db)
        create_roles(db)
        create_submissions(db)
        create_relationships(db)


def create_users(db):
    db.session.add(User(uco=445, email="foo@foo.cz", username="xfoo"))
    db.session.add(User(uco=123, email="bar@bar.com", username="xbar"))
    db.session.commit()


def create_courses(db):
    db.session.add(Course(name="C++", codename="PB161"))
    db.session.add(Course(name="C", codename="PB071"))
    db.session.commit()


def create_roles(db):
    db.session.add(Role(name='student', course=Course.query.all()[0]))
    db.session.add(Role(name='teacher', course=Course.query.all()[1]))
    db.session.commit()


def create_projects(db):
    db.session.add(Project(course=Course.query.all()[0], name="p1", test_files_source="repo"))
    db.session.add(Project(course=Course.query.all()[1], name="p2", test_files_source="repo2"))
    db.session.commit()


def create_groups(db):
    db.session.add(Group(course=Course.query.all()[0], name="g1"))
    db.session.add(Group(course=Course.query.all()[1], name="g2"))
    db.session.commit()


def create_submissions(db):
    # db.session.add(Submission(user=User.query.filter_by(username="xfoo").first(),
    #                          project=Project.query.filter_by(name="p1"), parameters=""))
    db.session.commit()


def create_relationships(db):
    user1 = User.query.filter_by(username="xfoo").first()
    user1.roles.append(Role.query.all()[0])
    user1.groups.append(Group.query.all()[0])
    db.session.commit()

